module DivideByMaterial
	
	def self.select_materials
		mod = Sketchup.active_model
		ent = mod.active_entities
		sel = mod.selection
		sel = ent if sel.empty?
		materials = mod.materials
		mat1=[];materials.each{|m|mat1<<m}
		mat2=[];materials.each{|m|mat2<< m.name}
		matn=mat2.join("|")
		ans=UI.inputbox(["Material:"," Max Size:"],[nil,1.m],[matn], "Divide By Material")
		if !ans then return end
		fn=ans[0].to_s;ms=ans[1].to_l; fi=mat2.index(fn);
		mod.start_operation "Divide by Material"
		@grp = ent.add_group; # create a group 
		@ge = @grp.entities;   # for c_line entities
		recurse(sel,mat1[fi],ms)
		mod.commit_operation
	end
	
	def self.recurse(ents, mat, ms)
		mod = Sketchup.active_model
		ent = mod.active_entities
		ents.each do |e|
			# puts e.material.display_name if e.material != nil
			if e.is_a? Sketchup::Group
				@pt0=e.bounds.min; @From_GorC = true
				tr = Geom::Transformation.new(@pt0)
				recurse(e.entities, mat, ms)
				@grp.transform! tr
		#		convert construction lines to edges	and erase guide lines	
				@ge.each {|cl| e.entities.add_line(cl.start,cl.end)}
				ent.erase_entities @grp
				@grp = ent.add_group; # create a group 
				@ge = @grp.entities;   # for c_line entities
				@From_GorC = false
			elsif e.is_a? Sketchup::ComponentInstance
				@pt0=e.bounds.min; @From_GorC = true
				tr = Geom::Transformation.new(@pt0)
				recurse(e.definition.entities, mat, ms)
				@grp.transform! tr
		#		convert construction lines to edges	and erase guide lines	
				@ge.each {|cl| e.definition.entities.add_line(cl.start,cl.end)}
				ent.erase_entities @grp
				@grp = ent.add_group; # create a group 
				@ge = @grp.entities;   # for c_line entities
				@From_GorC = false
			elsif e.is_a? Sketchup::Face
				unless e.material == nil
					puts e.material.name
					if e.material == mat
						pts=[];pts=e.outer_loop.vertices.collect{|v| v.position}
						self.divide_face(e,pts,ms)
						if !@From_GorC
						#	convert construction lines to edges	and erase guide lines
							@ge.each {|cl| edg=ent.add_line(cl.start,cl.end)}
							ent.erase_entities @grp
							@grp = ent.add_group; # create a group 
							@ge = @grp.entities;   # for c_line entities
						end
					end
				end
				unless e.back_material == nil
					puts e.back_material.name
					if e.back_material == mat
						pts=[];pts=e.outer_loop.vertices.collect{|v| v.position}
						self.divide_face(e,pts,ms)
						if !@From_GorC
						#	convert construction lines to edges	and erase guide lines
							@ge.each {|cl| ent.add_line(cl.start,cl.end)}
							ent.erase_entities @grp
							@grp = ent.add_group; # create a group 
							@ge = @grp.entities;   # for c_line entities
						end
					end
				end
			end
		end
	end
	
	def self.divide_face(face,pts,dmax)
		mod = Sketchup.active_model
		ent = mod.active_entities
		if pts.length > 4
			longest_side = 0.0; #find the longest side
			for i in -1...pts.length-1
				dist=pts[i-1].distance(pts[i]) + pts[i].distance(pts[i+1])
				if dist > longest_side
					longest_side = dist
					ndx = i
				end
			end
			ndx += pts.length if ndx < 0
			puts "ndx = #{ndx}"
			# make it the first side
			for i in 0...ndx
				tmp=pts.shift
				pts.push tmp
			end
		end
		d1=pts[1].distance(pts[0])
		d2=pts[1].distance(pts[2])
		if (d1 >= dmax && d2 >= dmax)
			xs=(d1/dmax).ceil; ys=(d2/dmax).ceil
			dx=d1/xs;dy=d2/ys
			v1=pts[1].vector_to(pts[0])
			v2=pts[1].vector_to(pts[2])
			edges=[]; edges=face.edges
			
			for i in 1...xs
				p0=pts[1].offset(v1,dx*i); #puts "p0=#{p0}"
				last_pt_out = false
				for j in 1..ys
					p1=p0.offset(v2,dy); #puts "p1=#{p1}"
					if !(face.classify_point(p1) == Sketchup::Face::PointOutside)
						if !last_pt_out
							edg = @ge.add_cline(p0,p1)
						else
							pt=self.find_intersection(p0,p1,edges)
							if pt
								edg = @ge.add_cline(pt,p1)
							else
								puts "no intersection found between #{p0} and #{p1}"
								ent.add_cpoint(p1)
							end
						end
						last_pt_out = false
					else
						if !last_pt_out
							pt=self.find_intersection(p0,p1,edges)
							if pt
								edg = @ge.add_cline(p0,pt)
							else
								puts "no intersection found between #{p0} and #{p1}"
								ent.add_cpoint(p1)
							end
						end
						last_pt_out = true
					end
					p0=p1
				end
			end
			
			for i in 1...ys
				p0=pts[1].offset(v2,dy*i)
				last_pt_out = false
				for j in 1..xs
					p1=p0.offset(v1,dx)
					if !(face.classify_point(p1) == Sketchup::Face::PointOutside)
						if !last_pt_out
							edg = @ge.add_cline(p0,p1)
						else
							pt=self.find_intersection(p0,p1,edges)
							if pt
								edg = @ge.add_cline(pt,p1)
							else
								puts "no intersection found between #{p0} and #{p1}"
								ent.add_cpoint(p1)
							end
						end
						last_pt_out = false
					else
						if !last_pt_out
							pt=self.find_intersection(p0,p1,edges)
							if pt
								edg = @ge.add_cline(p0,pt)
							else
								puts "no intersection found between #{p0} and #{p1}"
								ent.add_cpoint(p1)
							end
						end
						last_pt_out = true
					end
					p0=p1
				end
			end
		else
			puts "Max size is greater than short side of rectangle"
		end
	end
	
	def self.find_intersection(p0,p1,edges)
		ln0=[p0,p0.vector_to(p1)]
		for e in edges
			ln1=e.line; pp=Geom.intersect_line_line(ln0,ln1)
			if pp
				if self.is_between(pp,e.start.position,e.end.position)
					if self.is_between(pp,p0,p1)
						return pp
					end
				end
			end
		end
		return nil
	end
	
	def  self.is_between(p0,p1,p2)
	# --------------------------------------------------------------------------------
	#	Determine if point p0 is on the line and between end points p1 and p2
	# --------------------------------------------------------------------------------
		d1=p0.distance p1 
		d2=p0.distance p2 
		d3=p1.distance p2 
		return true if ((d1+d2) == d3)
		return false # p0 is not on line or between p1 and p2
	end
	
end

filename=File.basename(__FILE__)

if !file_loaded?(filename)
	UI.menu("Plugins").add_item("DBM") { DivideByMaterial.select_materials }
end

file_loaded(filename)
